"use strict";Object.defineProperty(exports, "__esModule", {value: true}); function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }// src/index.ts
var _crypto = require('crypto'); var _crypto2 = _interopRequireDefault(_crypto);
var _tschacha20 = require('ts-chacha20');
var _cryptojs = require('crypto-js'); var _cryptojs2 = _interopRequireDefault(_cryptojs);
var _argon2browser = require('argon2-browser'); var _argon2browser2 = _interopRequireDefault(_argon2browser);
function pbkdf2({ password, salt }) {
  console.log(salt, Buffer.from(salt).toString("hex"));
  const result = _cryptojs2.default.PBKDF2(password, Buffer.from(salt).toString("hex"), {
    keySize: 512 / 32,
    iterations: 1,
    hasher: _cryptojs2.default.algo.SHA256
  }).toString(_cryptojs2.default.enc.Base64);
  return Buffer.from(result, "base64");
}
async function argon2({ password, salt }) {
  const result = await _argon2browser2.default.hash({
    pass: password,
    salt,
    hashLen: 32,
    time: 2,
    mem: 32,
    parallelism: 1,
    type: _argon2browser2.default.ArgonType.Argon2d
  });
  return Buffer.from(result.hash);
}
function generateRandom(length = 16) {
  return Uint8Array.from(_crypto2.default.randomBytes(length));
}
async function aesEncrypt(data, password) {
  const salt = generateRandom(12);
  const key = await argon2({ password, salt });
  const encrypt = new (0, _tschacha20.Chacha20)(key.subarray(0, 32), salt).encrypt(
    Buffer.from(data, "utf8")
  );
  const packaged = Buffer.concat([salt, encrypt]);
  return packaged.toString("base64");
}
async function aesDecrypt(data, password) {
  const unpackaged = Buffer.from(data, "base64");
  const salt = unpackaged.subarray(0, 12);
  const input = unpackaged.subarray(12, data.length);
  const key = await argon2({ password, salt });
  const message = new (0, _tschacha20.Chacha20)(key.subarray(0, 32), salt).decrypt(input);
  return Buffer.from(message).toString("utf8");
}





exports.aesDecrypt = aesDecrypt; exports.aesEncrypt = aesEncrypt; exports.argon2 = argon2; exports.pbkdf2 = pbkdf2;
